diff --git a/src/backend/access/hash/hash.c b/src/backend/access/hash/hash.c
index 3eb5b1d..df54638 100644
--- a/src/backend/access/hash/hash.c
+++ b/src/backend/access/hash/hash.c
@@ -624,13 +624,9 @@ loop_top:
 			 * now that the primary page of the target bucket has been locked
 			 * (and thus can't be further split), check whether we need to
 			 * update our cached metapage data.
-			 *
-			 * NB: The check for InvalidBlockNumber is only needed for
-			 * on-disk compatibility with indexes created before we started
-			 * storing hashm_maxbucket in the primary page's hasho_prevblkno.
 			 */
-			if (bucket_opaque->hasho_prevblkno != InvalidBlockNumber &&
-				bucket_opaque->hasho_prevblkno > cachedmetap->hashm_maxbucket)
+			Assert(bucket_opaque->hasho_prevblkno != InvalidBlockNumber);
+			if (bucket_opaque->hasho_prevblkno > cachedmetap->hashm_maxbucket)
 			{
 				cachedmetap = _hash_getcachedmetap(rel, &metabuf, true);
 				Assert(cachedmetap != NULL);
diff --git a/src/backend/access/hash/hashpage.c b/src/backend/access/hash/hashpage.c
index 3cd4daa..bf1ffff 100644
--- a/src/backend/access/hash/hashpage.c
+++ b/src/backend/access/hash/hashpage.c
@@ -1564,16 +1564,12 @@ _hash_getbucketbuf_from_hashkey(Relation rel, uint32 hashkey, int access,
 		page = BufferGetPage(buf);
 		opaque = (HashPageOpaque) PageGetSpecialPointer(page);
 		Assert(opaque->hasho_bucket == bucket);
+		Assert(opaque->hasho_prevblkno != InvalidBlockNumber);
 
 		/*
 		 * If this bucket hasn't been split, we're done.
-		 *
-		 * NB: The check for InvalidBlockNumber is only needed for on-disk
-		 * compatibility with indexes created before we started storing
-		 * hashm_maxbucket in the primary page's hasho_prevblkno.
 		 */
-		if (opaque->hasho_prevblkno == InvalidBlockNumber ||
-			opaque->hasho_prevblkno <= metap->hashm_maxbucket)
+		if (opaque->hasho_prevblkno <= metap->hashm_maxbucket)
 			break;
 
 		/* Drop lock on this buffer, update cached metapage, and retry. */
